#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>
#include <string.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20100216

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)

#define YYPREFIX "yy"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
#ifdef YYPARSE_PARAM_TYPE
#define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
#else
#define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
#endif
#else
#define YYPARSE_DECL() yyparse(void)
#endif /* YYPARSE_PARAM */

extern int YYPARSE_DECL();

#line 2 "conf.y"
/*
 * $Id: conf.y,v 1.26 2005/04/17 15:20:32 nohar Exp $
 *
 * This file is part of the bip proproject
 * Copyright (C) 2004 Arnaud Cornet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

#include <stdlib.h>
#include "util.h"
#include "irc.h"
#include "tuple.h"
extern int yylex (void);
extern char *yytext;
extern int linec;

#define YYMALLOC bip_malloc

extern int yyerror(char *);

int yywrap()
{
	return 1;
}

/*int yydebug = 1;*/

list_t *root_list;

struct tuple *tuple_i_new(int type, int i)
{
	struct tuple *t;
	t = bip_malloc(sizeof(struct tuple));
	t->type = type;
	t->ndata = i;
	t->tuple_type = TUPLE_INT;
	return t;
}

struct tuple *tuple_p_new(int type, void *p)
{
	struct tuple *t;
	t = bip_malloc(sizeof(struct tuple));
	t->type = type;
	t->pdata = p;
	return t;
}

struct tuple *tuple_s_new(int type, void *p)
{
	struct tuple *t = tuple_p_new(type, p);
	t->tuple_type = TUPLE_STR;
	return t;
}

struct tuple *tuple_l_new(int type, void *p)
{
	struct tuple *t = tuple_p_new(type, p);
	t->tuple_type = TUPLE_LIST;
	return t;
}

#line 73 "conf.y"
typedef union {
	int number;
	char *string;
	void *list;
	struct tuple *tuple;
} YYSTYPE;
#line 109 "src/conf.c"
#define LEX_IP 257
#define LEX_EQ 258
#define LEX_PORT 259
#define LEX_CSS 260
#define LEX_SEMICOLON 261
#define LEX_CONNECTION 262
#define LEX_NETWORK 263
#define LEX_LBRA 264
#define LEX_RBRA 265
#define LEX_USER 266
#define LEX_NAME 267
#define LEX_NICK 268
#define LEX_SERVER 269
#define LEX_PASSWORD 270
#define LEX_SRCIP 271
#define LEX_HOST 272
#define LEX_VHOST 273
#define LEX_SOURCE_PORT 274
#define LEX_NONE 275
#define LEX_COMMENT 276
#define LEX_BUNCH 277
#define LEX_REALNAME 278
#define LEX_SSL 279
#define LEX_SSL_CHECK_MODE 280
#define LEX_SSL_CHECK_STORE 281
#define LEX_SSL_CLIENT_CERTFILE 282
#define LEX_CHANNEL 283
#define LEX_KEY 284
#define LEX_LOG_ROOT 285
#define LEX_LOG_FORMAT 286
#define LEX_LOG_LEVEL 287
#define LEX_BACKLOG_LINES 288
#define LEX_BACKLOG_NO_TIMESTAMP 289
#define LEX_BACKLOG 290
#define LEX_LOG 291
#define LEX_LOG_SYSTEM 292
#define LEX_LOG_SYNC_INTERVAL 293
#define LEX_FOLLOW_NICK 294
#define LEX_ON_CONNECT_SEND 295
#define LEX_AWAY_NICK 296
#define LEX_PID_FILE 297
#define LEX_IGN_FIRST_NICK 298
#define LEX_ALWAYS_BACKLOG 299
#define LEX_BLRESET_ON_TALK 300
#define LEX_BLRESET_CONNECTION 301
#define LEX_DEFAULT_USER 302
#define LEX_DEFAULT_NICK 303
#define LEX_DEFAULT_REALNAME 304
#define LEX_NO_CLIENT_AWAY_MSG 305
#define LEX_BL_MSG_ONLY 306
#define LEX_ADMIN 307
#define LEX_BIP_USE_NOTICE 308
#define LEX_CSS_PEM 309
#define LEX_AUTOJOIN_ON_KICK 310
#define LEX_IGNORE_CAPAB 311
#define LEX_BOOL 312
#define LEX_INT 313
#define LEX_STRING 314
#define YYERRCODE 256
static const short yylhs[] = {                           -1,
    0,    0,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    2,    2,    8,    8,    8,    4,    4,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,    5,    5,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,    3,    3,    9,    9,
    9,    1,    1,    7,    7,
};
static const short yylen[] = {                            2,
    0,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    4,
    4,    0,    3,    3,    3,    4,    0,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    4,    0,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    4,    3,    3,    3,    0,    3,    3,    3,
    3,    0,    3,    3,    3,
};
static const short yydefred[] = {                         1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   22,   27,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    2,    6,    7,    8,    0,    0,    3,    4,    5,   14,
   15,   16,   10,   11,   12,   13,   19,   17,   18,    9,
   20,    0,    0,    0,    0,    0,   21,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   72,    0,   23,   47,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   28,   24,    0,
   25,    0,   29,   30,   33,   34,   35,   39,   40,   41,
   45,   42,   43,   36,   37,   38,   44,   31,   32,    0,
   26,    0,    0,    0,   46,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   73,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   67,    0,    0,    0,    0,
    0,    0,    0,    0,   48,   75,   74,   50,   53,   49,
   52,   55,   56,   57,   54,   66,    0,   51,   59,   64,
   58,   60,   65,   61,   62,   63,    0,    0,    0,    0,
    0,    0,    0,   68,   69,   70,   71,
};
static const short yydgoto[] = {                          1,
  110,   45,  187,   46,  112,   21,  133,   65,  200,   85,
  153,
};
static const short yysindex[] = {                         0,
 -257, -251, -250, -245, -263, -260, -243, -242, -241, -238,
 -236, -235, -233, -232, -231, -221, -219, -217, -213, -211,
 -215, -266, -256, -262,    0,    0, -249, -247, -253, -240,
 -248, -237, -234, -227, -223, -244, -220, -218, -210, -214,
    0,    0,    0,    0, -255, -193,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -199, -201, -182, -181, -183,    0, -167, -157, -155,
 -154, -153, -146, -142, -141, -140, -139, -138, -137, -136,
 -135, -134, -133, -132, -131, -187,    0, -184,    0,    0,
 -185, -180, -179, -178, -177, -175, -173, -172, -171, -170,
 -169, -168, -166, -165, -162, -161, -160,    0,    0, -254,
    0, -212,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -127,
    0, -126, -128, -114,    0, -113, -111, -105, -104, -103,
 -102, -101, -100,  -99,  -98,  -97,  -96,  -95,  -94,  -92,
  -91,  -90,  -89, -144, -143,    0, -130, -129, -125, -124,
 -123, -122, -120, -119, -118,    0, -115, -112, -116, -110,
 -109, -108, -107,  -93,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -246,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -88,  -85,  -84,  -86,
 -106,  -87,  -83,    0,    0,    0,    0,
};
static const short yyrindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,
};
static const short yygindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
#define YYTABLESIZE 229
static const short yytable[] = {                          2,
   25,    3,    4,   26,  130,    5,   22,   23,    6,   61,
  131,   62,   24,   63,   27,   28,   29,  132,  196,   30,
  197,   31,   32,   64,   33,   34,   35,    7,    8,    9,
   10,   11,   12,   13,   14,   15,   36,  198,   37,   16,
   38,   17,   18,  199,   39,   41,   40,   42,   19,   44,
  134,   20,  135,  136,  137,  138,   43,  139,   86,   49,
  140,  141,   87,   51,   47,  142,   48,  143,   66,   56,
  144,   67,   50,   68,   52,   88,   69,   53,  145,   89,
   90,  146,  147,  148,   54,  149,   70,   71,   72,   55,
   91,   57,  150,   58,   73,   74,   75,  151,  152,   60,
   92,   59,   93,   94,   95,   76,   77,   78,   79,   80,
   81,   96,   82,   83,   84,   97,   98,   99,  100,  101,
  102,  103,  104,  105,  106,  107,  109,  111,  113,  108,
  154,  155,  156,  114,  115,  116,  117,  118,  119,  120,
  121,  122,  123,  157,  158,  124,  159,  125,  126,  127,
  128,  129,  160,  161,  162,  163,  164,  165,    0,  167,
  168,  169,  170,  171,  166,  172,  173,  174,  176,  201,
  177,  175,  202,  203,  204,    0,    0,    0,    0,    0,
    0,    0,    0,  178,  179,    0,    0,    0,  180,  181,
  182,  183,  184,    0,  185,  186,  188,  190,    0,  189,
    0,    0,  192,  191,  194,  193,    0,  205,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  195,    0,
    0,    0,    0,    0,    0,    0,  206,    0,  207,
};
static const short yycheck[] = {                        257,
  264,  259,  260,  264,  259,  263,  258,  258,  266,  265,
  265,  267,  258,  269,  258,  258,  258,  272,  265,  258,
  267,  258,  258,  279,  258,  258,  258,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  258,  284,  258,  297,
  258,  299,  300,  290,  258,  261,  258,  314,  306,  312,
  263,  309,  265,  266,  267,  268,  313,  270,  258,  313,
  273,  274,  264,  312,  314,  278,  314,  280,  262,  314,
  283,  265,  313,  267,  312,  258,  270,  312,  291,  261,
  264,  294,  295,  296,  312,  298,  280,  281,  282,  313,
  258,  312,  305,  312,  288,  289,  290,  310,  311,  314,
  258,  312,  258,  258,  258,  299,  300,  301,  302,  303,
  304,  258,  306,  307,  308,  258,  258,  258,  258,  258,
  258,  258,  258,  258,  258,  258,  314,  312,  314,  261,
  258,  258,  261,  314,  314,  314,  314,  313,  312,  312,
  312,  312,  312,  258,  258,  314,  258,  314,  314,  312,
  312,  312,  258,  258,  258,  258,  258,  258,   -1,  258,
  258,  258,  258,  258,  264,  258,  258,  258,  313,  258,
  314,  261,  258,  258,  261,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  314,  314,   -1,   -1,   -1,  314,  314,
  314,  314,  313,   -1,  314,  314,  312,  314,   -1,  312,
   -1,   -1,  312,  314,  312,  314,   -1,  314,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  312,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  314,   -1,  312,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 314
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"LEX_IP","LEX_EQ","LEX_PORT",
"LEX_CSS","LEX_SEMICOLON","LEX_CONNECTION","LEX_NETWORK","LEX_LBRA","LEX_RBRA",
"LEX_USER","LEX_NAME","LEX_NICK","LEX_SERVER","LEX_PASSWORD","LEX_SRCIP",
"LEX_HOST","LEX_VHOST","LEX_SOURCE_PORT","LEX_NONE","LEX_COMMENT","LEX_BUNCH",
"LEX_REALNAME","LEX_SSL","LEX_SSL_CHECK_MODE","LEX_SSL_CHECK_STORE",
"LEX_SSL_CLIENT_CERTFILE","LEX_CHANNEL","LEX_KEY","LEX_LOG_ROOT",
"LEX_LOG_FORMAT","LEX_LOG_LEVEL","LEX_BACKLOG_LINES","LEX_BACKLOG_NO_TIMESTAMP",
"LEX_BACKLOG","LEX_LOG","LEX_LOG_SYSTEM","LEX_LOG_SYNC_INTERVAL",
"LEX_FOLLOW_NICK","LEX_ON_CONNECT_SEND","LEX_AWAY_NICK","LEX_PID_FILE",
"LEX_IGN_FIRST_NICK","LEX_ALWAYS_BACKLOG","LEX_BLRESET_ON_TALK",
"LEX_BLRESET_CONNECTION","LEX_DEFAULT_USER","LEX_DEFAULT_NICK",
"LEX_DEFAULT_REALNAME","LEX_NO_CLIENT_AWAY_MSG","LEX_BL_MSG_ONLY","LEX_ADMIN",
"LEX_BIP_USE_NOTICE","LEX_CSS_PEM","LEX_AUTOJOIN_ON_KICK","LEX_IGNORE_CAPAB",
"LEX_BOOL","LEX_INT","LEX_STRING",
};
static const char *yyrule[] = {
"$accept : commands",
"commands :",
"commands : commands command LEX_SEMICOLON",
"command : LEX_LOG_ROOT LEX_EQ LEX_STRING",
"command : LEX_LOG_FORMAT LEX_EQ LEX_STRING",
"command : LEX_LOG_LEVEL LEX_EQ LEX_INT",
"command : LEX_IP LEX_EQ LEX_STRING",
"command : LEX_PORT LEX_EQ LEX_INT",
"command : LEX_CSS LEX_EQ LEX_BOOL",
"command : LEX_CSS_PEM LEX_EQ LEX_STRING",
"command : LEX_LOG LEX_EQ LEX_BOOL",
"command : LEX_LOG_SYSTEM LEX_EQ LEX_BOOL",
"command : LEX_LOG_SYNC_INTERVAL LEX_EQ LEX_INT",
"command : LEX_PID_FILE LEX_EQ LEX_STRING",
"command : LEX_BACKLOG_LINES LEX_EQ LEX_INT",
"command : LEX_BACKLOG_NO_TIMESTAMP LEX_EQ LEX_BOOL",
"command : LEX_BACKLOG LEX_EQ LEX_BOOL",
"command : LEX_BLRESET_ON_TALK LEX_EQ LEX_BOOL",
"command : LEX_BL_MSG_ONLY LEX_EQ LEX_BOOL",
"command : LEX_ALWAYS_BACKLOG LEX_EQ LEX_BOOL",
"command : LEX_NETWORK LEX_LBRA network LEX_RBRA",
"command : LEX_USER LEX_LBRA user LEX_RBRA",
"network :",
"network : network net_command LEX_SEMICOLON",
"net_command : LEX_NAME LEX_EQ LEX_STRING",
"net_command : LEX_SSL LEX_EQ LEX_BOOL",
"net_command : LEX_SERVER LEX_LBRA server LEX_RBRA",
"user :",
"user : user usr_command LEX_SEMICOLON",
"usr_command : LEX_NAME LEX_EQ LEX_STRING",
"usr_command : LEX_PASSWORD LEX_EQ LEX_STRING",
"usr_command : LEX_ADMIN LEX_EQ LEX_BOOL",
"usr_command : LEX_BIP_USE_NOTICE LEX_EQ LEX_BOOL",
"usr_command : LEX_SSL_CHECK_MODE LEX_EQ LEX_STRING",
"usr_command : LEX_SSL_CHECK_STORE LEX_EQ LEX_STRING",
"usr_command : LEX_SSL_CLIENT_CERTFILE LEX_EQ LEX_STRING",
"usr_command : LEX_DEFAULT_USER LEX_EQ LEX_STRING",
"usr_command : LEX_DEFAULT_NICK LEX_EQ LEX_STRING",
"usr_command : LEX_DEFAULT_REALNAME LEX_EQ LEX_STRING",
"usr_command : LEX_BACKLOG_LINES LEX_EQ LEX_INT",
"usr_command : LEX_BACKLOG_NO_TIMESTAMP LEX_EQ LEX_BOOL",
"usr_command : LEX_BACKLOG LEX_EQ LEX_BOOL",
"usr_command : LEX_BLRESET_ON_TALK LEX_EQ LEX_BOOL",
"usr_command : LEX_BLRESET_CONNECTION LEX_EQ LEX_BOOL",
"usr_command : LEX_BL_MSG_ONLY LEX_EQ LEX_BOOL",
"usr_command : LEX_ALWAYS_BACKLOG LEX_EQ LEX_BOOL",
"usr_command : LEX_CONNECTION LEX_LBRA connection LEX_RBRA",
"connection :",
"connection : connection con_command LEX_SEMICOLON",
"con_command : LEX_NAME LEX_EQ LEX_STRING",
"con_command : LEX_NETWORK LEX_EQ LEX_STRING",
"con_command : LEX_LOG LEX_EQ LEX_BOOL",
"con_command : LEX_NICK LEX_EQ LEX_STRING",
"con_command : LEX_USER LEX_EQ LEX_STRING",
"con_command : LEX_REALNAME LEX_EQ LEX_STRING",
"con_command : LEX_PASSWORD LEX_EQ LEX_STRING",
"con_command : LEX_VHOST LEX_EQ LEX_STRING",
"con_command : LEX_SOURCE_PORT LEX_EQ LEX_INT",
"con_command : LEX_AWAY_NICK LEX_EQ LEX_STRING",
"con_command : LEX_FOLLOW_NICK LEX_EQ LEX_BOOL",
"con_command : LEX_IGN_FIRST_NICK LEX_EQ LEX_BOOL",
"con_command : LEX_AUTOJOIN_ON_KICK LEX_EQ LEX_BOOL",
"con_command : LEX_IGNORE_CAPAB LEX_EQ LEX_BOOL",
"con_command : LEX_CHANNEL LEX_LBRA channel LEX_RBRA",
"con_command : LEX_ON_CONNECT_SEND LEX_EQ LEX_STRING",
"con_command : LEX_NO_CLIENT_AWAY_MSG LEX_EQ LEX_STRING",
"con_command : LEX_SSL_CHECK_MODE LEX_EQ LEX_STRING",
"channel :",
"channel : channel cha_command LEX_SEMICOLON",
"cha_command : LEX_NAME LEX_EQ LEX_STRING",
"cha_command : LEX_KEY LEX_EQ LEX_STRING",
"cha_command : LEX_BACKLOG LEX_EQ LEX_BOOL",
"server :",
"server : server ser_command LEX_SEMICOLON",
"ser_command : LEX_HOST LEX_EQ LEX_STRING",
"ser_command : LEX_PORT LEX_EQ LEX_INT",

};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;

typedef struct {
    unsigned stacksize;
    short    *s_base;
    short    *s_mark;
    short    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;

#define YYPURE 0

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static YYSTACKDATA yystack;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = data->s_mark - data->s_base;
    newss = (data->s_base != 0)
          ? (short *)realloc(data->s_base, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    data->s_base  = newss;
    data->s_mark = newss + i;

    newvs = (data->l_base != 0)
          ? (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack)) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 1:
#line 88 "conf.y"
	{ yyval.list = root_list = list_new(NULL); }
break;
case 2:
#line 89 "conf.y"
	{ list_add_last(yystack.l_mark[-2].list, yystack.l_mark[-1].tuple); yyval.list = yystack.l_mark[-2].list; }
break;
case 3:
#line 93 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_LOG_ROOT, yystack.l_mark[0].string); }
break;
case 4:
#line 94 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_LOG_FORMAT,
						yystack.l_mark[0].string); }
break;
case 5:
#line 96 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_LOG_LEVEL, yystack.l_mark[0].number); }
break;
case 6:
#line 97 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_IP, yystack.l_mark[0].string); }
break;
case 7:
#line 98 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_PORT, yystack.l_mark[0].number); }
break;
case 8:
#line 99 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_CSS, yystack.l_mark[0].number); }
break;
case 9:
#line 100 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_CSS_PEM, yystack.l_mark[0].string); }
break;
case 10:
#line 101 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_LOG, yystack.l_mark[0].number); }
break;
case 11:
#line 102 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_LOG_SYSTEM, yystack.l_mark[0].number); }
break;
case 12:
#line 103 "conf.y"
	{ yyval.tuple = tuple_i_new(
						LEX_LOG_SYNC_INTERVAL, yystack.l_mark[0].number); }
break;
case 13:
#line 105 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_PID_FILE, yystack.l_mark[0].string); }
break;
case 14:
#line 107 "conf.y"
	{
	           yyval.tuple = tuple_i_new(LEX_BACKLOG_LINES, yystack.l_mark[0].number);
		  }
break;
case 15:
#line 110 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BACKLOG_NO_TIMESTAMP, yystack.l_mark[0].number);
	       }
break;
case 16:
#line 113 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_BACKLOG, yystack.l_mark[0].number); }
break;
case 17:
#line 114 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BLRESET_ON_TALK, yystack.l_mark[0].number);
	       }
break;
case 18:
#line 117 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BL_MSG_ONLY, yystack.l_mark[0].number);
	       }
break;
case 19:
#line 120 "conf.y"
	{ yyval.tuple = tuple_i_new(
						LEX_ALWAYS_BACKLOG, yystack.l_mark[0].number); }
break;
case 20:
#line 123 "conf.y"
	{ yyval.tuple = tuple_l_new(LEX_NETWORK,
						yystack.l_mark[-1].list); }
break;
case 21:
#line 125 "conf.y"
	{ yyval.tuple = tuple_l_new(LEX_USER, yystack.l_mark[-1].list); }
break;
case 22:
#line 128 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 23:
#line 129 "conf.y"
	{ list_add_last(yystack.l_mark[-2].list, yystack.l_mark[-1].tuple); yyval.list = yystack.l_mark[-2].list; }
break;
case 24:
#line 132 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NAME, yystack.l_mark[0].string); }
break;
case 25:
#line 133 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_SSL, yystack.l_mark[0].number); }
break;
case 26:
#line 134 "conf.y"
	{
			yyval.tuple = tuple_l_new(LEX_SERVER, yystack.l_mark[-1].list); }
break;
case 27:
#line 138 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 28:
#line 139 "conf.y"
	{ list_add_last(yystack.l_mark[-2].list, yystack.l_mark[-1].tuple); yyval.list = yystack.l_mark[-2].list; }
break;
case 29:
#line 142 "conf.y"
	{
		   yyval.tuple = tuple_s_new(LEX_NAME, yystack.l_mark[0].string); }
break;
case 30:
#line 144 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_PASSWORD,
		yystack.l_mark[0].string); }
break;
case 31:
#line 146 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_ADMIN, yystack.l_mark[0].number); }
break;
case 32:
#line 147 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_BIP_USE_NOTICE, yystack.l_mark[0].number); }
break;
case 33:
#line 149 "conf.y"
	{ yyval.tuple = tuple_s_new(
			LEX_SSL_CHECK_MODE, yystack.l_mark[0].string); }
break;
case 34:
#line 151 "conf.y"
	{ yyval.tuple = tuple_s_new(
			LEX_SSL_CHECK_STORE, yystack.l_mark[0].string); }
break;
case 35:
#line 153 "conf.y"
	{ yyval.tuple = tuple_s_new(
			LEX_SSL_CLIENT_CERTFILE, yystack.l_mark[0].string); }
break;
case 36:
#line 155 "conf.y"
	{
		   yyval.tuple = tuple_s_new(LEX_DEFAULT_USER, yystack.l_mark[0].string); }
break;
case 37:
#line 157 "conf.y"
	{
		   yyval.tuple = tuple_s_new(LEX_DEFAULT_NICK, yystack.l_mark[0].string); }
break;
case 38:
#line 159 "conf.y"
	{
		   yyval.tuple = tuple_s_new(LEX_DEFAULT_REALNAME, yystack.l_mark[0].string); }
break;
case 39:
#line 161 "conf.y"
	{
	           yyval.tuple = tuple_i_new(LEX_BACKLOG_LINES, yystack.l_mark[0].number);
		  }
break;
case 40:
#line 164 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BACKLOG_NO_TIMESTAMP, yystack.l_mark[0].number);
	       }
break;
case 41:
#line 167 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_BACKLOG, yystack.l_mark[0].number); }
break;
case 42:
#line 168 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BLRESET_ON_TALK, yystack.l_mark[0].number);
	       }
break;
case 43:
#line 171 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BLRESET_CONNECTION, yystack.l_mark[0].number);
	       }
break;
case 44:
#line 174 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BL_MSG_ONLY, yystack.l_mark[0].number);
	       }
break;
case 45:
#line 177 "conf.y"
	{ yyval.tuple = tuple_i_new(
						LEX_ALWAYS_BACKLOG, yystack.l_mark[0].number); }
break;
case 46:
#line 179 "conf.y"
	{
				 yyval.tuple = tuple_l_new(LEX_CONNECTION, yystack.l_mark[-1].list); }
break;
case 47:
#line 183 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 48:
#line 184 "conf.y"
	{
	       list_add_last(yystack.l_mark[-2].list, yystack.l_mark[-1].tuple); yyval.list = yystack.l_mark[-2].list; }
break;
case 49:
#line 188 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NAME, yystack.l_mark[0].string); }
break;
case 50:
#line 189 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NETWORK,
			 yystack.l_mark[0].string); }
break;
case 51:
#line 191 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_LOG, yystack.l_mark[0].number); }
break;
case 52:
#line 192 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NICK, yystack.l_mark[0].string); }
break;
case 53:
#line 193 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_USER, yystack.l_mark[0].string); }
break;
case 54:
#line 194 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_REALNAME,
		 yystack.l_mark[0].string); }
break;
case 55:
#line 196 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_PASSWORD,
		 yystack.l_mark[0].string); }
break;
case 56:
#line 198 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_VHOST, yystack.l_mark[0].string); }
break;
case 57:
#line 199 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_SOURCE_PORT, yystack.l_mark[0].number); }
break;
case 58:
#line 201 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_AWAY_NICK,
						yystack.l_mark[0].string); }
break;
case 59:
#line 203 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_FOLLOW_NICK, yystack.l_mark[0].number); }
break;
case 60:
#line 205 "conf.y"
	{ yyval.tuple = tuple_i_new(
					   LEX_IGN_FIRST_NICK, yystack.l_mark[0].number); }
break;
case 61:
#line 207 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_AUTOJOIN_ON_KICK, yystack.l_mark[0].number); }
break;
case 62:
#line 209 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_IGNORE_CAPAB, yystack.l_mark[0].number); }
break;
case 63:
#line 211 "conf.y"
	{ yyval.tuple = tuple_l_new(
						LEX_CHANNEL, yystack.l_mark[-1].list); }
break;
case 64:
#line 213 "conf.y"
	{ yyval.tuple = tuple_s_new(
						LEX_ON_CONNECT_SEND, yystack.l_mark[0].string); }
break;
case 65:
#line 215 "conf.y"
	{ yyval.tuple = tuple_s_new(
						LEX_NO_CLIENT_AWAY_MSG, yystack.l_mark[0].string); }
break;
case 66:
#line 217 "conf.y"
	{ yyval.tuple = tuple_s_new(
			LEX_SSL_CHECK_MODE, yystack.l_mark[0].string); }
break;
case 67:
#line 220 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 68:
#line 221 "conf.y"
	{ list_add_last(yystack.l_mark[-2].list, yystack.l_mark[-1].tuple); yyval.list = yystack.l_mark[-2].list; }
break;
case 69:
#line 224 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NAME, yystack.l_mark[0].string); }
break;
case 70:
#line 225 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_KEY, yystack.l_mark[0].string); }
break;
case 71:
#line 226 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_BACKLOG, yystack.l_mark[0].number); }
break;
case 72:
#line 229 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 73:
#line 230 "conf.y"
	{ list_add_last(yystack.l_mark[-2].list, yystack.l_mark[-1].tuple); yyval.list = yystack.l_mark[-2].list; }
break;
case 74:
#line 233 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_HOST, yystack.l_mark[0].string); }
break;
case 75:
#line 234 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_PORT, yystack.l_mark[0].number); }
break;
#line 1015 "src/conf.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (short) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
